require 'date'
require 'logger'

module OrmDev
  class LogUtil

    ORMDEV_CLT_INFO_LOG_FLAG = '[OrmDev]'

    def self.debug(msg = '')
      puts msg
    end

    def self.info(msg = '')
      puts "#{ORMDEV_CLT_INFO_LOG_FLAG}#{msg}"
    end

    def self.link(link, message)
      puts message unless message.nil?
      unless link.nil?
        puts " - "  + link.blue.underlined

        if ENV["TERM_PROGRAM"] == "iTerm.app"
          puts " ( hold cmd and click links to open in a browser. )".magenta
        else
          puts " ( hold cmd and double click links to open in a browser. )".magenta
        end
      end
    end

    def self.print_command(content)
      puts content.green.bold
    end

    def self.print_success(content)
      puts '****************************************'.green
      puts "*    #{Time.new}         *".green
      puts '*                                      *'.green
      puts '*                 OK ~                 *'.green.bold
      puts '*                                      *'.green
      puts content
      puts '****************************************'.green
    end

    def self.print_error(content)
      puts '****************************************'.red
      puts "*    #{Time.new}         *".red
      puts '*                                      *'.red
      puts '*               Error ~                *'.red.bold
      puts '*                                      *'.red
      puts content
      puts '****************************************'.red
    end

  end
end